#include <dos.h>
#include <graph.h>

#define __VERSION__ "1.11"

void help(void);
void version(void);

void mscuron(void);
void mscuroff(void);
void msposxy(int, int);

int msbtns(void);
int msrow(void);
int mscol(void);

int msdet(void);

int main(int argc, char *argv[])
  { char bval='K', buffer[20];               /* K isn't a valid button value */
    int b_status=0, next=1, row, column;
    struct videoconfig vc;

    if (*argv[1]=='-'||*argv[1]=='/')
      { if(*(1+argv[1])=='?'||*(1+argv[1])=='h') help();
        if(*(1+argv[1])=='v') version(); }

    if (!msdet())
      { printf("Can't detect mouse.\n");
        exit(1); }

    _getvideoconfig(&vc);
    row=vc.numtextrows/2;         /* Default starting positions */
    column=vc.numtextcols/2;      /* in centre of screen        */

/* Note that _MOUSE has coordinate base 0,0 but DMOUSE uses a base of 1,1 */

    if(argc>1)
      { row=atoi(argv[next])-1;
	if(argc==3) column=atoi(argv[next+1])-1; }

    mscuron();
    msposxy(row, column);

    while(!(b_status=msbtns()));

    row=msrow()+1;
    column=mscol()+1;
    if(b_status==1) bval='L';
    if(b_status==2) bval='R';
    if(b_status==3||b_status==4) bval='M';

    mscuroff();

    set("row",itoa(row,buffer,10));
    set("col",itoa(column,buffer,10));

    buffer[0]=bval; buffer[1]=0;
    set("btn",buffer);

    while(kbhit()) getch();
    return 0;
  }

void help(void)
  { printf("\nDMOUSE version %s - Copyright 1995 David Cantrell - %s, %s\n\n", __VERSION__, __DATE__, __TIME__);
    printf("Use DMOUSE [row [col]]\n\n");
    printf("Where row and col are the starting row and column of the mouse cursor.  If\n");
    printf("you want to specify the COLUMN, you MUST specify the row.  If no row or\n");
    printf("column are specified, it defaults to the centre of the screen (or centre of\n");
    printf("column X if just a row is given).  Note that all co-ordinates take the top\n");
    printf("left corner of the screen as (0,0).\n\n");
    printf("Command-line switches are signified by either a '-' or a '/' character.\n");
    printf("Switches are case sensitive.\n\n");
    printf("Valid switches are:\n");
    printf("\t-h, -? ... Show this help\n");
    printf("\t-v ....... Show version information\n\n");
    printf("Invalid switches are not detected in this release, and will cause the\n");
    printf("initial cursor position to be a bit screwed\n");
    exit(3);
  }

void version(void)
  { printf("\nDMOUSE version %s - Copyright 1995 David Cantrell - %s, %s\n", __VERSION__, __DATE__, __TIME__);
    exit(3);
  }
